//+----------------------------------------------------------------------------+
//|                                                       ParserIni.mqh        |
//|                                                       Copyright  Zhunko   |
//|05.10.2013 - 11.02.2014                                vadim@zhunko.ru      |
//+----------------------------------------------------------------------------+
//|     "ParserIni.dll"   INI-.  |
//+----------------------------------------------------------------------------+---------------------------------------------------------------------------------------------------------+
//|    INI-.                                                                                                                                                        |
//|   1.    .                                                                                                                                                              |
//|   1.1.       .    -     ("//").                                                      |
//|   1.2.              ("\r\n").                                                                          |
//|   1.3.   -     .                                                                                                                         |
//|   1.4.           ("=").                                                                                                               |
//|   1.5.      .                                                                                                                                        |
//|   2.   .                                                                                                                                                                        |
//|   2.1.       ,   ,  ,      "End".                               |
//|   3.    .                                                                                                                                                              |
//|   3.1.          ,   , ,      ( (" ")).                        |
//|   3.2.        .                                                                                                                              |
//|   3.3.    ,  ,   ,    .                                                                                           |
//|   3.4.         ("|"),    (";")   (",").                                                                    |
//|             ( )  ,      .                                                              |
//|            (","), (";"), ("|")   .                                                                                                               |
//|             : Param=1,2,3,4,5,6,7,8,9                                                                                                                |
//|             : Param=1,2,3;4,5,6;7,8,9                                                                                                                |
//|             : Param=1,2,3;4,5,6;7,8,9|1,2,3;4,5,6;7,8,9|1,2,3;4,5,6;7,8,9                                                                              |
//|   3.5.         ("+")   ("-").                                                                                                           |
//|   3.6.             ("\r\n").                                                                          |
//|   4.   .                                                                                                                                                                  |
//|   4.1.     ("//")  ("/**/").                                                                                                                                 |
//|   4.2.     .                                                                                                                            |
//|   5.   .                                                                                                                                                                      |
//|   5.1.        ,        .                                                              |
//|   5.2.       .                                                                                                                           |
//|   5.3.         .                                                                                                              |
//|   5.4.        ,  ,            . : "# []".   |
//|              ,      .      .                                              |
//|   5.5.        .                                                                                                                      |
//|           1.         ("#")          (""). : #UserSpace0. |
//|           2.         ("["),        ("]"). : [UserSpace0].      |
//|   5.6.         .    .                                                                |
//|   5.7.            ("#End")     ("[End]")   .                                  |
//|   5.8.     ,          -       .                |
//|   5.9.         "End".                                                                                                         |
//|   6.   .                                                                                                                                                                       |
//|   6.1.       ("\r")     ("\n")    --> ("\r\n").                                                            |
//|   6.2.     ("/**/")          ("\r\n")      .                                 |
//|   6.3.            -.                                                                                                  |
//|   6.4.               ("=")      ("\r\n").                                           |
//|   6.5.             ("//").                                                                 |
//|   6.6.          ("//").                                                                                     |
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+

#ifndef size_t
 #ifdef  TERMINAL_X64
  #define size_t            ulong
 #else
  #define size_t            uint
 #endif
#endif

#ifndef BOOL
 #define BOOL               int
#endif

#ifndef WORD
 #define WORD               ushort
#endif

#ifndef DWORD
 #define DWORD              uint
#endif

//
#import "ParserIni.dll"
 //
 // 1.   INI-.
 //
 // 1.1.   INI-.
 void ParserClose();
 //=========================================================================================================================================
 // 1.2.   INI-.
 void ParserDelete();
 //=========================================================================================================================================
 // 1.3.1.   INI-    ,      ,    ,
 //         ,   ,    -.
 //           INI-     "Open()".     "Close()".
 //           ANSI-.
 void ParserOpenA(uchar &szFileName[],   //     INI-.
                                         //    ,      :
                                         // "...\MetaTrader 4\experts\files\MyFolder\MyFile.ini".
                                         //           .
                  uchar &szSectionTag[], //   . ,        .
                                         // : "# "  "[]".
                                         //      ,      .
                                         //      .
                  BOOL   bUnicode);      //      (ANSI/UNICODE)    .
                                         //         .
                                         //          UTF-16LE (FF FE).
                                         //        ,   bUnicode=true 
                                         //   UTF-16LE.       ,   
                                         //     .
                                         //   UTF-16LE,   .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 1.3.2.   INI-    ,      ,    ,
 //         ,   ,    -.
 //           INI-     "Open()".     "Close()".
 //           UNICODE-.
 void ParserOpenW(string sFileName,   //     INI-.
                                      //    ,      :
                                      // "...\MetaTrader 4\experts\files\MyFolder\MyFile.ini".
                                      //           .
                  string sSectionTag, //   . ,        .
                                      // : "# "  "[]".
                                      //      ,      .
                                      //      .
                  BOOL   bUnicode);   //      (ANSI/UNICODE)    .
                                      //         .
                                      //          UTF-16LE (FF FE).
                                      //        ,   bUnicode=true 
                                      //   UTF-16LE.       ,   
                                      //     .
                                      //   UTF-16LE,   .
 //
 // 2. .
 //
 // 2.1.1.   TRUE,   ,  - FALSE.    ANSI-.
 BOOL ParserIsKeyA(uchar &szName[]); //  .      .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.2.   TRUE,   ,  - FALSE.    UNICODE-.
 BOOL ParserIsKeyW(string sName); //  .      .
 //=========================================================================================================================================
 // 2.2.1.   TRUE,   ,  - FALSE.    ANSI-.
 BOOL ParserIsSectionA(uchar &szName[]); //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 2.2.2.   TRUE,   ,  - FALSE.    UNICODE-.
 BOOL ParserIsSectionW(string sName); //  .
 //=========================================================================================================================================
 // 2.3.1.     -  INI-    .    ANSI-.
 int ParserKeysA(uchar &szName[]); //     .      .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 2.3.2.     -  INI-    .    UNICODE-.
 int ParserKeysW(string sName); //     .      .
 //=========================================================================================================================================
 // 2.4.1.       .   ,     .
 //           ANSI-.
 string ParserSectionByIndexA(size_t stIndex); //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 2.4.2.       .   ,     .
 //           UNICODE-.
 string ParserSectionByIndexW(size_t stIndex); //  .
 //=========================================================================================================================================
 // 2.5.1.      INI-    .    ANSI-.
 int ParserSectionsA(uchar &szName[]); //    .       .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 2.5.2.      INI-    .    UNICODE-.
 int ParserSectionsW(string sName); //    .       .
 //=========================================================================================================================================
 // 2.6.    INI-  .
 int ParserSize();
 //
 // 3. .
 //
 // 3.1.      .
 void ParserClearText();
 //=========================================================================================================================================
 // 3.2.       .
 //         INI-     .
 //         INI-    .
 void ParserMake();
 //=========================================================================================================================================
 // 3.3.1.     INI-   .    ANSI-.
 string ParserTextA();
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 3.3.2.     INI-   .    UNICODE-.
 string ParserTextW();
 //
 // 4.   .
 //
 // 4.1.               .
 void ParserSectionClose();
 //=========================================================================================================================================
 // 4.2.1.   .    ANSI-.
 void ParserSectionOpenA(uchar &szSection[]); //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 4.2.2.   .    UNICODE-.
 void ParserSectionOpenW(string sSection); //  .
 //
 // 5.  .
 //
 // 5.1.1.   .    ANSI-.
 void ParserSetCommentA(uchar &szComment[]); //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.1.2.   .    UNICODE-.
 void ParserSetCommentW(string sComment); //   .
 //=========================================================================================================================================
 // 5.2.1.    INI-.    ANSI-.
 void ParserSetTitleA(uchar &szTitle[]); //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.2.2.    INI-.    UNICODE-.
 void ParserSetTitleW(string sTitle); //   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.3.     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.3.1.1.       bool.   ,       .
 //             ANSI-.
 void ParserSetKeyBoolA(uchar &szKey[], // .
                        bool   bValue); //    bool.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.1.2.       bool.   ,       .
 //             UNICODE-.
 void ParserSetKeyBoolW(string sKey,    // .
                        bool   bValue); //    bool.
 //=========================================================================================================================================
 // 5.3.2.1.       char.   ,       .
 //             ANSI-.
 void ParserSetKeyCharA(uchar &szKey[], // .
                        char   cValue); //    char.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.2.2.       char.   ,       .
 //             UNICODE-.
 void ParserSetKeyCharW(string sKey,    // .
                        char   cValue); //    char.
 //=========================================================================================================================================
 // 5.3.3.1.       uchar.   ,       .
 //             ANSI-.
 void ParserSetKeyUCharA(uchar &szKey[],  // .
                         uchar  ucValue); //    uchar.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.3.2.       uchar.   ,       .
 //             UNICODE-.
 void ParserSetKeyUCharW(string sKey,     // .
                         uchar  ucValue); //    uchar.
 //=========================================================================================================================================
 // 5.3.4.1.       short.   ,       .
 //             ANSI-.
 void ParserSetKeyShortA(uchar &szKey[],  // .
                         short  shValue); //    short.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.4.2.       short.   ,       .
 //             UNICODE-.
 void ParserSetKeyShortW(string sKey,     // .
                         short  shValue); //    short.
 //=========================================================================================================================================
 // 5.3.5.1.       ushort.   ,       .
 //             ANSI-.
 void ParserSetKeyUShortA(uchar &szKey[],   // .
                          ushort ushValue); //    ushort.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.5.2.       ushort.   ,       .
 //             UNICODE-.
 void ParserSetKeyUShortW(string sKey,      // .
                          ushort ushValue); //    ushort.
 //=========================================================================================================================================
 // 5.3.6.1.       int.   ,       .
 //             ANSI-.
 void ParserSetKeyIntA(uchar &szKey[], // .
                       int    nValue); //    int.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.6.2.       int.   ,       .
 //             UNICODE-.
 void ParserSetKeyIntW(string sKey,    // .
                       int    nValue); //    int.
 //=========================================================================================================================================
 // 5.3.7.1.       uint.   ,       .
 //             ANSI-.
 void ParserSetKeyUIntA(uchar &szKey[],  // .
                        uint   uiValue); //    uint.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.7.2.       uint.   ,       .
 //             UNICODE-.
 void ParserSetKeyUIntW(string sKey,     // .
                        uint   uiValue); //    uint.
 //=========================================================================================================================================
 // 5.3.8.1.       long.   ,       .
 //             ANSI-.
 void ParserSetKeyLong64A(uchar &szKey[], // .
                          long   lValue); //    long.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.8.2.       long.   ,       .
 //             UNICODE-.
 void ParserSetKeyLong64W(string sKey,    // .
                          long   lValue); //    long.
 //=========================================================================================================================================
 // 5.3.9.1.       long.   ,       .
 //             ANSI-.
 void ParserSetKeyULong64A(uchar &szKey[],  // .
                           ulong  ulValue); //    long.
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.9.2.       long.   ,       .
 //             UNICODE-.
 void ParserSetKeyULong64W(string sKey,     // .
                           ulong  ulValue); //    long.
 //=========================================================================================================================================
 // 5.3.10.1.       float.   ,       .
 //             ANSI-.
 void ParserSetKeyFloatA(uchar &szKey[],    // .
                         float  fValue,     //    float.
                         WORD   wDecimals); //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.10.2.       float.   ,       .
 //             UNICODE-.
 void ParserSetKeyFloatW(string sKey,       // .
                         float  fValue,     //    float.
                         WORD   wDecimals); //     .
 //=========================================================================================================================================
 // 5.3.11.1.       double.   ,       .
 //             ANSI-.
 void ParserSetKeyDoubleA(uchar &szKey[],    // .
                          double dValue,     //    double.
                          int    nDecimals); //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.11.2.       double.   ,       .
 //             UNICODE-.
 void ParserSetKeyDoubleW(string sKey,       // .
                          double dValue,     //    double.
                          int    nDecimals); //     .
 //=========================================================================================================================================
 // 5.3.12.1.     .   ,       .
 //             ANSI-.
 void ParserSetKeyStringA(uchar &szKey[], // .
                          string sValue); //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.12.2.     .   ,       .
 //             UNICODE-.
 void ParserSetKeyStringW(string sKey,    // .
                          string sValue); //  .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.4.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.4.1.1.         bool.   ,       .
 //             ANSI-.
 void ParserSetKeyBoolArrayA(uchar &szKey[],   // .
                             bool  &abArray[], //         bool.
                             size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.1.2.         bool.   ,       .
 //             UNICODE-.
 void ParserSetKeyBoolArrayW(string sKey,      // .
                             bool  &abArray[], //         bool.
                             size_t stSize);   //  .
 //=========================================================================================================================================
 // 5.4.2.1.         char.   ,       .
 //             ANSI-.
 void ParserSetKeyCharArrayA(uchar &szKey[],   // .
                             char  &acArray[], //         char.
                             size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.2.2.         char.   ,       .
 //             UNICODE-.
 void ParserSetKeyCharArrayW(string sKey,      // .
                             char  &acArray[], //         char.
                             size_t stSize);   //  .
 //=========================================================================================================================================
 // 5.4.3.1.         uchar.   ,       .
 //             ANSI-.
 void ParserSetKeyUCharArrayA(uchar &szKey[],    // .
                              uchar &aucArray[], //         uchar.
                              size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.3.2.         uchar.   ,       .
 //             UNICODE-.
 void ParserSetKeyUCharArrayW(string sKey,       // .
                              uchar &aucArray[], //         uchar.
                              size_t stSize);    //  .
 //=========================================================================================================================================
 // 5.4.4.1.         short.   ,       .
 //             ANSI-.
 void ParserSetKeyShortArrayA(uchar &szKey[],    // .
                              short &ashArray[], //         short.
                              size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.4.2.         short.   ,       .
 //             UNICODE-.
 void ParserSetKeyShortArrayW(string sKey,       // .
                              short &ashArray[], //         short.
                              size_t stSize);    //  .
 //=========================================================================================================================================
 // 5.4.5.1.         ushort.   ,       .
 //             ANSI-.
 void ParserSetKeyUShortArrayA(uchar  &szKey[],     // .
                               ushort &aushArray[], //         ushort.
                               size_t  stSize);     //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.5.2.         ushort.   ,       .
 //             UNICODE-.
 void ParserSetKeyUShortArrayW(string  sKey,        // .
                               ushort &aushArray[], //         ushort.
                               size_t  stSize);     //  .
 //=========================================================================================================================================
 // 5.4.6.1.         int.   ,       .
 //             ANSI-.
 void ParserSetKeyIntArrayA(uchar &szKey[],   // .
                            int   &anArray[], //         int.
                            size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.6.2.         int.   ,       .
 //             UNICODE-.
 void ParserSetKeyIntArrayW(string sKey,      // .
                            int   &anArray[], //         int.
                            size_t stSize);   //  .
 //=========================================================================================================================================
 // 5.4.7.1.         uint.   ,       .
 //             ANSI-.
 void ParserSetKeyUIntArrayA(uchar &szKey[],    // .
                             uint  &auiArray[], //         uint.
                             size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.7.2.         uint.   ,       .
 //             UNICODE-.
 void ParserSetKeyUIntArrayW(string sKey,       // .
                             uint  &auiArray[], //         uint.
                             size_t stSize);    //  .
 //=========================================================================================================================================
 // 5.4.8.1.         long.   ,       .
 //             ANSI-.
 void ParserSetKeyLongArrayA(uchar &szKey[],   // .
                             long  &alArray[], //         long.
                             size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.8.2.         long.   ,       .
 //             UNICODE-.
 void ParserSetKeyLongArrayW(string sKey,      // .
                             long  &alArray[], //         long.
                             size_t stSize);   //  .
 //=========================================================================================================================================
 // 5.4.9.1.         long.   ,       .
 //             ANSI-.
 void ParserSetKeyULongArrayA(uchar &szKey[],    // .
                              long  &aulArray[], //         long.
                              size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.9.2.         long.   ,       .
 //             UNICODE-.
 void ParserSetKeyULongArrayW(string sKey,       // .
                              long  &aulArray[], //         long.
                              size_t stSize);    //  .
 //=========================================================================================================================================
 // 5.4.10.1.         float.   ,       .
 //             ANSI-.
 void ParserSetKeyFloatArrayA(uchar &szKey[],    // .
                              float &afArray[],  //         float.
                              size_t stSize,     //  .
                              WORD   wDecimals); //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.10.2.         float.   ,       .
 //             UNICODE-.
 void ParserSetKeyFloatArrayW(string sKey,       // .
                              float &afArray[],  //         float.
                              size_t stSize,     //  .
                              WORD   wDecimals); //     .
 //=========================================================================================================================================
 // 5.4.11.1.         double.   ,       .
 //             ANSI-.
 void ParserSetKeyDoubleArrayA(uchar  &szKey[],    // .
                               double &adArray[],  //         double.
                               size_t  stSize,     //  .
                               int     nDecimals); //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.11.2.         double.   ,       .
 //             UNICODE-.
 void ParserSetKeyDoubleArrayW(string  sKey,       // .
                               double &adArray[],  //         double.
                               size_t  stSize,     //  .
                               int     nDecimals); //     .
 //=========================================================================================================================================
 // 5.4.13.1.     MQL-  .   ,       .
 //             ANSI-.
 void ParserSetKeyStringArrayMA(uchar  &szKey[],   // .
                                string &asArray[], //        MQL-.
                                size_t  stSize);   //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.13.2.     MQL-  .   ,       .
 //             UNICODE-.
 void ParserSetKeyStringArrayMW(string  sKey,      // .
                                string &asArray[], //        MQL-.
                                size_t  stSize);   //    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.5.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.5.1.1.         bool.   ,       .
 //             ANSI-.
 void ParserSetKeyBoolArray2A(uchar &szKey[],      // .
                              bool  &a2bArray[][], //         bool.
                              size_t stSize1,      //    .
                              size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.1.2.         bool.   ,       .
 //             UNICODE-.
 void ParserSetKeyBoolArray2W(string sKey,         // .
                              bool  &a2bArray[][], //         bool.
                              size_t stSize1,      //    .
                              size_t stSize2);     //    .
 //=========================================================================================================================================
 // 5.5.2.1.         char.   ,       .
 //             ANSI-.
 void ParserSetKeyCharArray2A(uchar &szKey[],      // .
                              char  &a2cArray[][], //         char.
                              size_t stSize1,      //    .
                              size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.2.2.         char.   ,       .
 //             UNICODE-.
 void ParserSetKeyCharArray2W(string sKey,         // .
                              char  &a2cArray[][], //         char.
                              size_t stSize1,      //    .
                              size_t stSize2);     //    .
 //=========================================================================================================================================
 // 5.5.3.1.         uchar.   ,       .
 //             ANSI-.
 void ParserSetKeyUCharArray2A(uchar &szKey[],       // .
                               uchar &a2ucArray[][], //         uchar.
                               size_t stSize1,       //    .
                               size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.3.2.         uchar.   ,       .
 //             UNICODE-.
 void ParserSetKeyUCharArray2W(string sKey,          // .
                               uchar &a2ucArray[][], //         uchar.
                               size_t stSize1,       //    .
                               size_t stSize2);      //    .
 //=========================================================================================================================================
 // 5.5.4.1.         short.   ,       .
 //             ANSI-.
 void ParserSetKeyShortArray2A(uchar &szKey[],       // .
                               short &a2shArray[][], //         short.
                               size_t stSize1,       //    .
                               size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.4.2.         short.   ,       .
 //             UNICODE-.
 void ParserSetKeyShortArray2W(string sKey,          // .
                               short &a2shArray[][], //         short.
                               size_t stSize1,       //    .
                               size_t stSize2);      //    .
 //=========================================================================================================================================
 // 5.5.5.1.         ushort.   ,       .
 //             ANSI-.
 void ParserSetKeyUShortArray2A(uchar  &szKey[],        // .
                                ushort &a2ushArray[][], //         ushort.
                                size_t  stSize1,        //    .
                                size_t  stSize2);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.5.2.         ushort.   ,       .
 //             UNICODE-.
 void ParserSetKeyUShortArray2W(string  sKey,           // .
                                ushort &a2ushArray[][], //         ushort.
                                size_t  stSize1,        //    .
                                size_t  stSize2);       //    .
 //=========================================================================================================================================
 // 5.5.6.1.         int.   ,       .
 //             ANSI-.
 void ParserSetKeyIntArray2A(uchar &szKey[],      // .
                             int   &a2nArray[][], //         int.
                             size_t stSize1,      //    .
                             size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.6.2.         int.   ,       .
 //             UNICODE-.
 void ParserSetKeyIntArray2W(string sKey,         // .
                             int   &a2nArray[][], //         int.
                             size_t stSize1,      //    .
                             size_t stSize2);     //    .
 //=========================================================================================================================================
 // 5.5.7.1.         uint.   ,       .
 //             ANSI-.
 void ParserSetKeyUIntArray2A(uchar &szKey[],       // .
                              uint  &a2uiArray[][], //         uint.
                              size_t stSize1,       //    .
                              size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.7.2.         uint.   ,       .
 //             UNICODE-.
 void ParserSetKeyUIntArray2W(string sKey,          // .
                              uint  &a2uiArray[][], //         uint.
                              size_t stSize1,       //    .
                              size_t stSize2);      //    .
 //=========================================================================================================================================
 // 5.5.8.1.         long.   ,       .
 //             ANSI-.
 void ParserSetKeyLongArray2A(uchar &szKey[],      // .
                              long  &a2lArray[][], //         long.
                              size_t stSize1,      //    .
                              size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.8.2.         long.   ,       .
 //             UNICODE-.
 void ParserSetKeyLongArray2W(string sKey,         // .
                              long  &a2lArray[][], //         long.
                              size_t stSize1,      //    .
                              size_t stSize2);     //    .
 //=========================================================================================================================================
 // 5.5.9.1.         long.   ,       .
 //             ANSI-.
 void ParserSetKeyULongArray2A(uchar &szKey[],       // .
                               long  &a2ulArray[][], //         long.
                               size_t stSize1,       //    .
                               size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.9.2.         long.   ,       .
 //             UNICODE-.
 void ParserSetKeyULongArray2W(string sKey,          // .
                               long  &a2ulArray[][], //         long.
                               size_t stSize1,       //    .
                               size_t stSize2);      //    .
 //=========================================================================================================================================
 // 5.5.10.1.         float.   ,       .
 //             ANSI-.
 void ParserSetKeyFloatArray2A(uchar &szKey[],      // .
                               float &a2fArray[][], //         float.
                               size_t stSize1,      //    .
                               size_t stSize2,      //    .
                               WORD   wDecimals);   //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.10.2.         float.   ,       .
 //             UNICODE-.
 void ParserSetKeyFloatArray2W(string sKey,         // .
                               float &a2fArray[][], //         float.
                               size_t stSize1,      //    .
                               size_t stSize2,      //    .
                               WORD   wDecimals);   //     .
 //=========================================================================================================================================
 // 5.5.11.1.         double.   ,       .
 //             ANSI-.
 void ParserSetKeyDoubleArray2A(uchar  &szKey[],      // .
                                double &a2dArray[][], //         double.
                                size_t  stSize1,      //    .
                                size_t  stSize2,      //    .
                                int     nDecimals);   //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.11.2.         double.   ,       .
 //             UNICODE-.
 void ParserSetKeyDoubleArray2W(string  sKey,         // .
                                double &a2dArray[][], //         double.
                                size_t  stSize1,      //    .
                                size_t  stSize2,      //    .
                                int     nDecimals);   //     .
 //=========================================================================================================================================
 // 5.5.13.1.     MQL-  .   ,       .
 //             ANSI-.
 void ParserSetKeyStringArray2MA(uchar  &szKey[],       // .
                                 string &a2SMqlStr[][], //        MQL-.
                                 size_t  stSize1,       //    .
                                 size_t  stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.13.2.     MQL-  .   ,       .
 //             UNICODE-.
 void ParserSetKeyStringArray2MW(string  sKey,          // .
                                 string &a2SMqlStr[][], //        MQL-.
                                 size_t  stSize1,       //    .
                                 size_t  stSize2);      //    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.6.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.6.1.1.         bool.   ,       .
 //             ANSI-.
 void ParserSetKeyBoolArray3A(uchar &szKey[],        // .
                              bool  &a3bArray[][][], //         bool.
                              size_t stSize1,        //    .
                              size_t stSize2,        //    .
                              size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.1.2.         bool.   ,       .
 //             UNICODE-.
 void ParserSetKeyBoolArray3W(string sKey,           // .
                              bool  &a3bArray[][][], //         bool.
                              size_t stSize1,        //    .
                              size_t stSize2,        //    .
                              size_t stSize3);       //    .
 //=========================================================================================================================================
 // 5.6.2.1.         char.   ,       .
 //             ANSI-.
 void ParserSetKeyCharArray3A(uchar &szKey[],        // .
                              char  &a3cArray[][][], //         char.
                              size_t stSize1,        //    .
                              size_t stSize2,        //    .
                              size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.2.2.         char.   ,       .
 //             UNICODE-.
 void ParserSetKeyCharArray3W(string sKey,           // .
                              char  &a3cArray[][][], //         char.
                              size_t stSize1,        //    .
                              size_t stSize2,        //    .
                              size_t stSize3);       //    .
 //=========================================================================================================================================
 // 5.6.3.1.         uchar.   ,       .
 //             ANSI-.
 void ParserSetKeyUCharArray3A(uchar &szKey[],         // .
                               uchar &a3ucArray[][][], //         uchar.
                               size_t stSize1,         //    .
                               size_t stSize2,         //    .
                               size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.3.2.         uchar.   ,       .
 //             UNICODE-.
 void ParserSetKeyUCharArray3W(string sKey,            // .
                               uchar &a3ucArray[][][], //         uchar.
                               size_t stSize1,         //    .
                               size_t stSize2,         //    .
                               size_t stSize3);        //    .
 //=========================================================================================================================================
 // 5.6.4.1.         short.   ,       .
 //             ANSI-.
 void ParserSetKeyShortArray3A(uchar &szKey[],         // .
                               short &a3shArray[][][], //         short.
                               size_t stSize1,         //    .
                               size_t stSize2,         //    .
                               size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.4.2.         short.   ,       .
 //             UNICODE-.
 void ParserSetKeyShortArray3W(string sKey,            // .
                               short &a3shArray[][][], //         short.
                               size_t stSize1,         //    .
                               size_t stSize2,         //    .
                               size_t stSize3);        //    .
 //=========================================================================================================================================
 // 5.6.5.1.         ushort.   ,       .
 //             ANSI-.
 void ParserSetKeyUShortArray3A(uchar  &szKey[],          // .
                                ushort &a3ushArray[][][], //         ushort.
                                size_t  stSize1,          //    .
                                size_t  stSize2,          //    .
                                size_t  stSize3);         //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.5.2.         ushort.   ,       .
 //             UNICODE-.
 void ParserSetKeyUShortArray3W(string  sKey,             // .
                                ushort &a3ushArray[][][], //         ushort.
                                size_t  stSize1,          //    .
                                size_t  stSize2,          //    .
                                size_t  stSize3);         //    .
 //=========================================================================================================================================
 // 5.6.6.1.         int.   ,       .
 //             ANSI-.
 void ParserSetKeyIntArray3A(uchar &szKey[],        // .
                             int   &a3nArray[][][], //         int.
                             size_t stSize1,        //    .
                             size_t stSize2,        //    .
                             size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.6.2.         int.   ,       .
 //             UNICODE-.
 void ParserSetKeyIntArray3W(string sKey,           // .
                             int   &a3nArray[][][], //         int.
                             size_t stSize1,        //    .
                             size_t stSize2,        //    .
                             size_t stSize3);       //    .
 //=========================================================================================================================================
 // 5.6.7.1.         uint.   ,       .
 //             ANSI-.
 void ParserSetKeyUIntArray3A(uchar &szKey[],         // .
                              uint  &a3uiArray[][][], //         uint.
                              size_t stSize1,         //    .
                              size_t stSize2,         //    .
                              size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.7.2.         uint.   ,       .
 //             UNICODE-.
 void ParserSetKeyUIntArray3W(string sKey,            // .
                              uint  &a3uiArray[][][], //         uint.
                              size_t stSize1,         //    .
                              size_t stSize2,         //    .
                              size_t stSize3);        //    .
 //=========================================================================================================================================
 // 5.6.8.1.         long.   ,       .
 //             ANSI-.
 void ParserSetKeyLongArray3A(uchar &szKey[],        // .
                              long  &a3lArray[][][], //         long.
                              size_t stSize1,        //    .
                              size_t stSize2,        //    .
                              size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.8.2.         long.   ,       .
 //             UNICODE-.
 void ParserSetKeyLongArray3W(string sKey,           // .
                              long  &a3lArray[][][], //         long.
                              size_t stSize1,        //    .
                              size_t stSize2,        //    .
                              size_t stSize3);       //    .
 //=========================================================================================================================================
 // 5.6.9.1.         long.   ,       .
 //             ANSI-.
 void ParserSetKeyULongArray3A(uchar &szKey[],         // .
                               long  &a3ulArray[][][], //         long.
                               size_t stSize1,         //    .
                               size_t stSize2,         //    .
                               size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.9.2.         long.   ,       .
 //             UNICODE-.
 void ParserSetKeyULongArray3W(string sKey,            // .
                               long  &a3ulArray[][][], //         long.
                               size_t stSize1,         //    .
                               size_t stSize2,         //    .
                               size_t stSize3);        //    .
 //=========================================================================================================================================
 // 5.6.10.1.         float.   ,       .
 //              ANSI-.
 void ParserSetKeyFloatArray3A(uchar &szKey[],        // .
                               float &a3fArray[][][], //         float.
                               size_t stSize1,        //    .
                               size_t stSize2,        //    .
                               size_t stSize3,        //    .
                               WORD   wDecimals);     //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.10.2.         float.   ,       .
 //              UNICODE-.
 void ParserSetKeyFloatArray3W(string sKey,           // .
                               float &a3fArray[][][], //         float.
                               size_t stSize1,        //    .
                               size_t stSize2,        //    .
                               size_t stSize3,        //    .
                               WORD   wDecimals);     //     .
 //=========================================================================================================================================
 // 5.6.11.1.         double.   ,       .
 //              ANSI-.
 void ParserSetKeyDoubleArray3A(uchar  &szKey[],        // .
                                double &a3dArray[][][], //         double.
                                size_t  stSize1,        //    .
                                size_t  stSize2,        //    .
                                size_t  stSize3,        //    .
                                int     nDecimals);     //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.11.2.         double.   ,       .
 //              UNICODE-.
 void ParserSetKeyDoubleArray3W(string  sKey,           // .
                                double &a3dArray[][][], //         double.
                                size_t  stSize1,        //    .
                                size_t  stSize2,        //    .
                                size_t  stSize3,        //    .
                                int     nDecimals);     //     .
 //=========================================================================================================================================
 // 5.6.13.1.     MQL-  .   ,       .
 //              ANSI-.
 void ParserSetKeyStringArray3MA(uchar  &szKey[],        // .
                                 string &a3sArray[][][], //        MQL-.
                                 size_t  stSize1,        //    .
                                 size_t  stSize2,        //    .
                                 size_t  stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.13.2.     MQL-  .   ,       .
 //              UNICODE-.
 void ParserSetKeyStringArray3MW(string  sKey,           // .
                                 string &a3sArray[][][], //        MQL-.
                                 size_t  stSize1,        //    .
                                 size_t  stSize2,        //    .
                                 size_t  stSize3);       //    .
 //
 // 6.  .
 //
 // 6.1.     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.1.1.1.       bool   .
 //            ,   .    ANSI-.
 bool ParserGetKeyBoolA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.1.2.       bool   .
 //            ,   .    UNICODE-.
 bool ParserGetKeyBoolW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.2.1.       char   .
 //            ,   .    ANSI-.
 char ParserGetKeyCharA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.2.2.       char   .
 //            ,   .    UNICODE-.
 char ParserGetKeyCharW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.3.1.       uchar   .
 //            ,   .    ANSI-.
 uchar ParserGetKeyUCharA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.3.2.       uchar   .
 //            ,   .    UNICODE-.
 uchar ParserGetKeyUCharW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.4.1.       short   .
 //            ,   .    ANSI-.
 short ParserGetKeyShortA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.4.2.       short   .
 //            ,   .    UNICODE-.
 short ParserGetKeyShortW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.5.1.       ushort   .
 //            ,   .    ANSI-.
 ushort ParserGetKeyUShortA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.5.2.       ushort   .
 //            ,   .    UNICODE-.
 ushort ParserGetKeyUShortW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.6.1.       int   .
 //            ,   .    ANSI-.
 int ParserGetKeyIntA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.6.2.       int   .
 //            ,   .    UNICODE-.
 int ParserGetKeyIntW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.7.1.       uint   .
 //            ,   .    ANSI-.
 uint ParserGetKeyUIntA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.7.2.       uint   .
 //            ,   .    UNICODE-.
 uint ParserGetKeyUIntW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.8.1.       long   .
 //            ,   .    ANSI-.
 long ParserGetKeyLong64A(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.8.2.       long   .
 //            ,   .    UNICODE-.
 long ParserGetKeyLong64W(string sKey); // .
 //=========================================================================================================================================
 // 6.1.9.1.       long   .
 //            ,   .    ANSI-.
 long ParserGetKeyULong64A(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.9.2.       long   .
 //            ,   .    UNICODE-.
 long ParserGetKeyULong64W(string sKey); // .
 //=========================================================================================================================================
 // 6.1.10.1.       float   .
 //             ,   .    ANSI-.
 float ParserGetKeyFloatA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.10.2.       float   .
 //             ,   .    UNICODE-.
 float ParserGetKeyFloatW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.11.1.       double   .
 //             ,   .    ANSI-.
 double ParserGetKeyDoubleA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.11.2.       double   .
 //             ,   .    UNICODE-.
 double ParserGetKeyDoubleW(string sKey); // .
 //=========================================================================================================================================
 // 6.1.12.1.        .
 //             ,   .    ANSI-.
 string ParserGetKeyStringA(uchar &szKey[]); // .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.12.2.        .
 //             ,   .    UNICODE-.
 string ParserGetKeyStringW(string sKey); // .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.2.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.2.1.1.          bool.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyBoolArrayA(uchar &szKey[],   // .
                               bool  &abArray[], //         bool.
                               size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.1.2.          bool.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyBoolArrayW(string sKey,      // .
                               bool  &abArray[], //         bool.
                               size_t stSize);   //  .
 //=========================================================================================================================================
 // 6.2.2.1.          char.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyCharArrayA(uchar &szKey[],   // .
                               char  &acArray[], //         char.
                               size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.2.2.          char.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyCharArrayW(string sKey,      // .
                               char  &acArray[], //         char.
                               size_t stSize);   //  .
 //=========================================================================================================================================
 // 6.2.3.1.          uchar.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUCharArrayA(uchar &szKey[],    // .
                                uchar &aucArray[], //         uchar.
                                size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.3.2.          uchar.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUCharArrayW(string sKey,       // .
                                uchar &aucArray[], //         uchar.
                                size_t stSize);    //  .
 //=========================================================================================================================================
 // 6.2.4.1.          short.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyShortArrayA(uchar &szKey[],    // .
                                short &ashArray[], //         short.
                                size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.4.2.          short.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyShortArrayW(string sKey,       // .
                                short &ashArray[], //         short.
                                size_t stSize);    //  .
 //=========================================================================================================================================
 // 6.2.5.1.          ushort.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUShortArrayA(uchar  &szKey[],     // .
                                 ushort &aushArray[], //         ushort.
                                 size_t  stSize);     //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.5.2.          ushort.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUShortArrayW(string  sKey,        // .
                                 ushort &aushArray[], //         ushort.
                                 size_t  stSize);     //  .
 //=========================================================================================================================================
 // 6.2.6.1.          int.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyIntArrayA(uchar &szKey[],   // .
                              int   &anArray[], //         int.
                              size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.6.2.          int.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyIntArrayW(string sKey,      // .
                              int   &anArray[], //         int.
                              size_t stSize);   //  .
 //=========================================================================================================================================
 // 6.2.7.1.          uint.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUIntArrayA(uchar &szKey[],    // .
                               uint  &auiArray[], //         uint.
                               size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.7.2.          uint.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUIntArrayW(string sKey,       // .
                               uint  &auiArray[], //         uint.
                               size_t stSize);    //  .
 //=========================================================================================================================================
 // 6.2.8.1.          long.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyLongArrayA(uchar &szKey[],   // .
                               long  &alArray[], //         long.
                               size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.8.2.          long.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyLongArrayW(string sKey,      // .
                               long  &alArray[], //         long.
                               size_t stSize);   //  .
 //=========================================================================================================================================
 // 6.2.9.1.          long.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyULongArrayA(uchar &szKey[],    // .
                                ulong &aulArray[], //         long.
                                size_t stSize);    //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.9.2.          long.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyULongArrayW(string sKey,       // .
                                ulong &aulArray[], //         long.
                                size_t stSize);    //  .
 //=========================================================================================================================================
 // 6.2.10.1.          float.     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyFloatArrayA(uchar &szKey[],   // .
                                float &afArray[], //         float.
                                size_t stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.10.2.          float.     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyFloatArrayW(string sKey,      // .
                                float &afArray[], //         float.
                                size_t stSize);   //  .
 //=========================================================================================================================================
 // 6.2.11.1.          double.     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyDoubleArrayA(uchar  &szKey[],   // .
                                 double &adArray[], //         double.
                                 size_t  stSize);   //  .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.11.2.          double.     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyDoubleArrayW(string  sKey,      // .
                                 double &adArray[], //         double.
                                 size_t  stSize);   //  .
 //=========================================================================================================================================
 // 6.2.13.1.      MQL-  .     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyStringArrayMA(uchar  &szKey[],   // .
                                  string &asArray[], //        MQL-.
                                  size_t  stSize);   //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.13.2.      MQL-  .     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyStringArrayMW(string  sKey,      // .
                                  string &asArray[], //        MQL-.
                                  size_t  stSize);   //    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.3.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.3.1.1.          bool.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyBoolArray2A(uchar &szKey[],      // .
                                bool  &a2bArray[][], //         bool.
                                size_t stSize1,      //    .
                                size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.1.2.          bool.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyBoolArray2W(string sKey,         // .
                                bool  &a2bArray[][], //         bool.
                                size_t stSize1,      //    .
                                size_t stSize2);     //    .
 //=========================================================================================================================================
 // 6.3.2.1.          char.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyCharArray2A(uchar &szKey[],      // .
                                char  &a2cArray[][], //         char.
                                size_t stSize1,      //    .
                                size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.2.2.          char.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyCharArray2W(string sKey,         // .
                                char  &a2cArray[][], //         char.
                                size_t stSize1,      //    .
                                size_t stSize2);     //    .
 //=========================================================================================================================================
 // 6.3.3.1.          uchar.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUCharArray2A(uchar &szKey[],       // .
                                 uchar &a2ucArray[][], //         uchar.
                                 size_t stSize1,       //    .
                                 size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.3.2.          uchar.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUCharArray2W(string sKey,          // .
                                 uchar &a2ucArray[][], //         uchar.
                                 size_t stSize1,       //    .
                                 size_t stSize2);      //    .
 //=========================================================================================================================================
 // 6.3.4.1.          short.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyShortArray2A(uchar &szKey[],       // .
                                 short &a2shArray[][], //         short.
                                 size_t stSize1,       //    .
                                 size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.4.2.          short.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyShortArray2W(string sKey,          // .
                                 short &a2shArray[][], //         short.
                                 size_t stSize1,       //    .
                                 size_t stSize2);      //    .
 //=========================================================================================================================================
 // 6.3.5.1.          ushort.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUShortArray2A(uchar  &szKey[],        // .
                                  ushort &a2ushArray[][], //         ushort.
                                  size_t  stSize1,        //    .
                                  size_t  stSize2);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.5.2.          ushort.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUShortArray2W(string  sKey,           // .
                                  ushort &a2ushArray[][], //         ushort.
                                  size_t  stSize1,        //    .
                                  size_t  stSize2);       //    .
 //=========================================================================================================================================
 // 6.3.6.1.          int.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyIntArray2A(uchar &szKey[],      // .
                               int   &a2nArray[][], //         int.
                               size_t stSize1,      //    .
                               size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.6.2.          int.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyIntArray2W(string sKey,         // .
                               int   &a2nArray[][], //         int.
                               size_t stSize1,      //    .
                               size_t stSize2);     //    .
 //=========================================================================================================================================
 // 6.3.7.1.          uint.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUIntArray2A(uchar &szKey[],       // .
                                uint  &a2uiArray[][], //         uint.
                                size_t stSize1,       //    .
                                size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.7.2.          uint.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUIntArray2W(string sKey,          // .
                                uint  &a2uiArray[][], //         uint.
                                size_t stSize1,       //    .
                                size_t stSize2);      //    .
 //=========================================================================================================================================
 // 6.3.8.1.          long.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyLongArray2A(uchar &szKey[],      // .
                                long  &a2lArray[][], //         long.
                                size_t stSize1,      //    .
                                size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.8.2.          long.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyLongArray2W(string sKey,         // .
                                long  &a2lArray[][], //         long.
                                size_t stSize1,      //    .
                                size_t stSize2);     //    .
 //=========================================================================================================================================
 // 6.3.9.1.          long.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyULongArray2A(uchar &szKey[],       // .
                                 ulong &a2ulArray[][], //         long.
                                 size_t stSize1,       //    .
                                 size_t stSize2);      //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.9.2.          long.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyULongArray2W(string sKey,          // .
                                 ulong &a2ulArray[][], //         long.
                                 size_t stSize1,       //    .
                                 size_t stSize2);      //    .
 //=========================================================================================================================================
 // 6.3.10.1.          float.     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyFloatArray2A(uchar &szKey[],      // .
                                 float &a2fArray[][], //         float.
                                 size_t stSize1,      //    .
                                 size_t stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.10.2.          float.     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyFloatArray2W(string sKey,         // .
                                 float &a2fArray[][], //         float.
                                 size_t stSize1,      //    .
                                 size_t stSize2);     //    .
 //=========================================================================================================================================
 // 6.3.11.1.          double.     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyDoubleArray2A(uchar  &szKey[],      // .
                                  double &a2dArray[][], //         double.
                                  size_t  stSize1,      //    .
                                  size_t  stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.11.2.          double.     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyDoubleArray2W(string  sKey,         // .
                                  double &a2dArray[][], //         double.
                                  size_t  stSize1,      //    .
                                  size_t  stSize2);     //    .
 //=========================================================================================================================================
 // 6.3.13.1.      MQL-  .     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyStringArray2MA(uchar  &szKey[],      // .
                                   string &a2sArray[][], //        MQL-.
                                   size_t  stSize1,      //    .
                                   size_t  stSize2);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.13.2.      MQL-  .     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyStringArray2MW(string  sKey,         // .
                                   string &a2sArray[][], //        MQL-.
                                   size_t  stSize1,      //    .
                                   size_t  stSize2);     //    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.4.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.4.1.1.          bool.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyBoolArray3A(uchar &szKey[],        // .
                                bool  &a3bArray[][][], //         bool.
                                size_t stSize1,        //    .
                                size_t stSize2,        //    .
                                size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.1.2.          bool.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyBoolArray3W(string sKey,           // .
                                bool  &a3bArray[][][], //         bool.
                                size_t stSize1,        //    .
                                size_t stSize2,        //    .
                                size_t stSize3);       //    .
 //=========================================================================================================================================
 // 6.4.2.1.          char.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyCharArray3A(uchar &szKey[],        // .
                                char  &a3cArray[][][], //         char.
                                size_t stSize1,        //    .
                                size_t stSize2,        //    .
                                size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.2.2.          char.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyCharArray3W(string sKey,           // .
                                char  &a3cArray[][][], //         char.
                                size_t stSize1,        //    .
                                size_t stSize2,        //    .
                                size_t stSize3);       //    .
 //=========================================================================================================================================
 // 6.4.3.1.          uchar.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUCharArray3A(uchar &szKey[],         // .
                                 uchar &a3ucArray[][][], //         uchar.
                                 size_t stSize1,         //    .
                                 size_t stSize2,         //    .
                                 size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.3.2.          uchar.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUCharArray3W(string sKey,            // .
                                 uchar &a3ucArray[][][], //         uchar.
                                 size_t stSize1,         //    .
                                 size_t stSize2,         //    .
                                 size_t stSize3);        //    .
 //=========================================================================================================================================
 // 6.4.4.1.          short.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyShortArray3A(uchar &szKey[],         // .
                                 short &a3shArray[][][], //         short.
                                 size_t stSize1,         //    .
                                 size_t stSize2,         //    .
                                 size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.4.2.          short.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyShortArray3W(string sKey,            // .
                                 short &a3shArray[][][], //         short.
                                 size_t stSize1,         //    .
                                 size_t stSize2,         //    .
                                 size_t stSize3);        //    .
 //=========================================================================================================================================
 // 6.4.5.1.          ushort.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUShortArray3A(uchar  &szKey[],          // .
                                  ushort &a3ushArray[][][], //         ushort.
                                  size_t  stSize1,          //    .
                                  size_t  stSize2,          //    .
                                  size_t  stSize3);         //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.5.2.          ushort.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUShortArray3W(string  sKey,             // .
                                  ushort &a3ushArray[][][], //         ushort.
                                  size_t  stSize1,          //    .
                                  size_t  stSize2,          //    .
                                  size_t  stSize3);         //    .
 //=========================================================================================================================================
 // 6.4.6.1.          int.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyIntArray3A(uchar &szKey[],        // .
                               int   &a3nArray[][][], //         int.
                               size_t stSize1,        //    .
                               size_t stSize2,        //    .
                               size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.6.2.          int.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyIntArray3W(string sKey,           // .
                               int   &a3nArray[][][], //         int.
                               size_t stSize1,        //    .
                               size_t stSize2,        //    .
                               size_t stSize3);       //    .
 //=========================================================================================================================================
 // 6.4.7.1.          uint.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyUIntArray3A(uchar &szKey[],         // .
                                uint  &a3uiArray[][][], //         uint.
                                size_t stSize1,         //    .
                                size_t stSize2,         //    .
                                size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.7.2.          uint.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyUIntArray3W(string sKey,            // .
                                uint  &a3uiArray[][][], //         uint.
                                size_t stSize1,         //    .
                                size_t stSize2,         //    .
                                size_t stSize3);        //    .
 //=========================================================================================================================================
 // 6.4.8.1.          long.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyLongArray3A(uchar &szKey[],        // .
                                long  &a3lArray[][][], //         long.
                                size_t stSize1,        //    .
                                size_t stSize2,        //    .
                                size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.8.2.          long.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyLongArray3W(string sKey,           // .
                                long  &a3lArray[][][], //         long.
                                size_t stSize1,        //    .
                                size_t stSize2,        //    .
                                size_t stSize3);       //    .
 //=========================================================================================================================================
 // 6.4.9.1.          long.     .
 //            ,   .    ANSI-.
 size_t ParserGetKeyULongArray3A(uchar &szKey[],         // .
                                 ulong &a3ulArray[][][], //         long.
                                 size_t stSize1,         //    .
                                 size_t stSize2,         //    .
                                 size_t stSize3);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.9.2.          long.     .
 //            ,   .    UNICODE-.
 size_t ParserGetKeyULongArray3W(string sKey,            // .
                                 ulong &a3ulArray[][][], //         long.
                                 size_t stSize1,         //    .
                                 size_t stSize2,         //    .
                                 size_t stSize3);        //    .
 //=========================================================================================================================================
 // 6.4.10.1.          float.     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyFloatArray3A(uchar &szKey[],        // .
                                 float &a3fArray[][][], //         float.
                                 size_t stSize1,        //    .
                                 size_t stSize2,        //    .
                                 size_t stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.10.2.          float.     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyFloatArray3W(string sKey,           // .
                                 float &a3fArray[][][], //         float.
                                 size_t stSize1,        //    .
                                 size_t stSize2,        //    .
                                 size_t stSize3);       //    .
 //=========================================================================================================================================
 // 6.4.11.1.          double.     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyDoubleArray3A(uchar  &szKey[],        // .
                                  double &a3dArray[][][], //         double.
                                  size_t  stSize1,        //    .
                                  size_t  stSize2,        //    .
                                  size_t  stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.11.2.          double.     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyDoubleArray3W(string  sKey,           // .
                                  double &a3dArray[][][], //         double.
                                  size_t  stSize1,        //    .
                                  size_t  stSize2,        //    .
                                  size_t  stSize3);       //    .
 //=========================================================================================================================================
 // 6.4.13.1.      MQL-  .     .
 //             ,   .    ANSI-.
 size_t ParserGetKeyStringArray3MA(uchar  &szKey[],        // .
                                   string &a3sArray[][][], //        MQL-.
                                   size_t  stSize1,        //    .
                                   size_t  stSize2,        //    .
                                   size_t  stSize3);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.13.2.      MQL-  .     .
 //             ,   .    UNICODE-.
 size_t ParserGetKeyStringArray3MW(string  sKey,           // .
                                   string &a3sArray[][][], //        MQL-.
                                   size_t  stSize1,        //    .
                                   size_t  stSize2,        //    .
                                   size_t  stSize3);       //    .
 //
#import
//