//+----------------------------------------------------------------------------+
//|                                                    Check_ParserIni.dll.mq5 |
//|                                                    Copyright  Zhunko      |
//|05.10.2013 - 11.02.2014                             vadim@zhunko.ru         |
//+----------------------------------------------------------------------------+
//
#property copyright "Copyright  Zhunko"
#property link      "vadim@zhunko.ru"
#property show_inputs
#property strict
//----
#include <ParserIni.mqh> //    "ParserIni.dll".
//----
input string FileName   = "CheckParser.ini"; //  INI-.
input string SectionTag = "[]";              //   . ,        . : "# "  "[]".
input bool   Write      = false;             //   INI-.
input bool   Read       = false;             //   INI-.
input bool   Clear      = false;             //  INI-.
input bool   Delete     = false;             //  INI-.
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
 {
  int    i = 0, j = 0, k = 0, l = 0;
  int    nSize = 0;
  string sComment = "";
  int    a1nOutput[10] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
  int    a1nInput[10] = {0};
  int    a2nOutput[3][3] = {1, 2, 3,  4, 5, 6,  7, 8, 9};
  int    a2nInput[3][3] = {0};
  int    a3nOutput[2][3][4] = {1, 2, 3, 4,  5, 6, 7, 8,  9, 10, 11, 12,  21, 22, 23, 24,  25, 26, 27, 28,  29, 30, 31, 32};
  int    a3nInput[2][3][4] = {0};
  double a1dOutput[10] = {1.123, 2.234, 3.345, 4.456, 5.567, 6.678, 7.789, 8.89101, 9.91011, 10.1011};
  double a1dInput[10] = {0};
  double a2dOutput[3][3] = {1.123, 2.234, 3.345,  4.456, 5.567, 6.678,  7.789, 8.89101, 9.91011};
  double a2dInput[3][3] = {0};
  double a3dOutput[2][3][3] = {1.123, 2.234, 3.345,  4.456, 5.567, 6.678,  7.789, 8.89101, 9.91011,  21.123, 22.234, 23.345,  24.456, 25.567, 26.678,  27.789, 28.89101, 29.91011};
  double a3dInput[2][3][3] = {0};
  string a1sOutput[10] = {"AUD", "USD", "GBP", "JPY", "CAD", "NZD", "RUR", "EUR", "ZAR", "CHF"};
  string a1sInput[10];
  string a2sOutput[3][3] = {"AUD", "USD", "GBP",  "JPY", "CAD", "NZD",  "RUR", "EUR", "ZAR"};
  string a2sInput[3][3];
  string a3sOutput[2][3][3] = {"AUD", "USD", "GBP",  "JPY", "CAD", "NZD",  "RUR", "EUR", "ZAR",  "DKK", "SEK", "SGD",  "MXN", "NOK", "HUF",  "PLN", "CNH", "HKD"};
  string a3sInput[2][3][3];
  //====   . ===============================================================================================================================================================================================
  //      .         !
  for (i = 0; i < 10; i++) a1sInput[i] = string(i) + "  ";
  for (i = 0, k = 0; i < 3; i++) for (j = 0; j < 3; j++, k++) a2sInput[i][j] = string(k) + "  ";
  for (i = 0, l = 0; i < 2; i++)
   for (j = 0; j < 3; j++)
    for (k = 0; k < 3; k++, l++) a3sInput[i][j][k] = string(l) + "   ";
  //====    INI-. ==================================================================================================================================================================================================
  if (Write)
   {//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "TEST_WRITE\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 1.4.2.   INI-    ,      ,    ,  ,   ,    -.
    //           INI-     "Open()".     "Close()".
    ParserOpenW(FileName, SectionTag, true);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.2.2.    INI-.
    ParserSetTitleW("  ."); //   .
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.1.2.   .
    ParserSetCommentW("   INT."); //   .
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.3.6.2.       INT.   ,       .
    ParserSetKeyIntW("ValueInt", 1234);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.1.2.   .
    ParserSetCommentW("   DOUBLE    3   ."); //   .
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.3.11.2.       DOUBLE.   ,       .
    ParserSetKeyDoubleW("ValueDouble", 987.654321, 3);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.1.2.   .
    ParserSetCommentW(" ."); //   .
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.3.12.2.     .   ,       .
    ParserSetKeyStringW("ValueString", " !"); //  .
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.1.2.   .
    ParserSetCommentW("  ."); //   .
    for (i = 1; i <= 3; i++)
     {//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      // 4.2.2.     .
      ParserSectionOpenW("Section_" + string(i)); //  .
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      // 5.3.6.2.       INT.   ,       .
      ParserSetKeyIntW("ValueInt", 1234 + i);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      // 5.3.11.2.       DOUBLE.   ,       .
      ParserSetKeyDoubleW("ValueDouble", 987.654321 + i, 3);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      // 5.3.12.2.     .   ,       .
      ParserSetKeyStringW("ValueString", string(i) + "  !");
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
     }
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 4.1.     .   ,       - ,    - .
    ParserSectionClose();
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.4.6.2.         INT.   ,       .
    ParserSetKeyIntArrayW("ArrayInt1", a1nOutput, ArraySize(a1nOutput));
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.5.6.2.         INT.   ,       .
    ParserSetKeyIntArray2W("ArrayInt2", a2nOutput, ArrayRange(a2nOutput, 0), ArrayRange(a2nOutput, 1));
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.6.6.2.         INT.   ,       .
    ParserSetKeyIntArray3W("ArrayInt3", a3nOutput, ArrayRange(a3nOutput, 0), ArrayRange(a3nOutput, 1), ArrayRange(a3nOutput, 2));
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.4.11.2.         DOUBLE.   ,       .
    ParserSetKeyDoubleArrayW("ArrayDouble1", a1dOutput, ArraySize(a1dOutput), 5);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.5.11.2.         DOUBLE.   ,       .
    ParserSetKeyDoubleArray2W("ArrayDouble2", a2dOutput, ArrayRange(a2dOutput, 0), ArrayRange(a2dOutput, 1), 5);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.6.11.2.         DOUBLE.   ,       .
    ParserSetKeyDoubleArray3W("ArrayDouble3", a3dOutput, ArrayRange(a3dOutput, 0), ArrayRange(a3dOutput, 1), ArrayRange(a3dOutput, 2), 5);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.4.13.2.     MQL4-  .   ,       .
    ParserSetKeyStringArrayMW("ArrayStr1", a1sOutput, ArraySize(a1sOutput));
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.5.13.2.     MQL4-  .   ,       .
    ParserSetKeyStringArray2MW("ArrayStr2", a2sOutput, ArrayRange(a2sOutput, 0), ArrayRange(a2sOutput, 1));
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 5.6.13.2.     MQL4-  .   ,       .
    ParserSetKeyStringArray3MW("ArrayStr3", a3sOutput, ArrayRange(a3sOutput, 0), ArrayRange(a3sOutput, 1), ArrayRange(a3sOutput, 2));
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 1.2.   INI-.
    ParserClose();
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   }
  //====   INI-. ============================================================================================================================================================================================================
  if (Read)
   {//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "TEST_READ\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 1.4.2.   INI-    ,      ,    ,  ,   ,    -.
    //           INI-     "Open()".     "Close()".
    ParserOpenW(FileName, SectionTag, true);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.1.6.1.       INT   .   ,   .
    sComment = sComment + " 6.1.6.1.       INT   .   ,   .\n";
    Comment(sComment);
    if (ParserGetKeyIntW("ValueInt") != 1234) Alert("6.1.6.1.    \"ParserGetKeyIntW()\".");
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.1.11.1.       DOUBLE   .   ,   .
    sComment = sComment + " 6.1.11.1.       DOUBLE   .   ,   .\n";
    Comment(sComment);
    if (ParserGetKeyDoubleW("ValueDouble") != 987.654) Alert("6.1.11.1.    \"ParserGetKeyDoubleW()\".");
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.1.12.1.        .   ,   .
    sComment = sComment + " 6.1.12.1.        .   ,   .\n";
    Comment(sComment);
    if (ParserGetKeyStringW("ValueString") != " !") Alert("6.1.12.1.    \"ParserGetKeyStringW()\".");
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 2.5.1.      INI-    .
    sComment = sComment + " 2.5.1.      INI-    .\n";
    nSize = ParserSectionsW("");
    if (nSize != 3) Alert(i, " 2.5.1.    \"ParserSectionsW()\".    .");
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "\n  .\n";
    Comment(sComment);
    for (i = 1; i <= nSize; i++)
     {//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      // 2.4.1.       .   ,     .
      sComment = sComment + string(i) + " 2.4.1.       .   ,     .\n";
      if (ParserSectionByIndexW(i - 1) != ("Section_" + string(i))) Alert(i, " 2.4.1.    \"ParserSectionByIndexW()\".");
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      // 4.2.2.     .
      ParserSectionOpenW("Section_" + string(i)); //  .
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      //  6.1.6.1.       INT   .   ,   .
      sComment = sComment + string(i) + " 6.1.6.1.       INT   .   ,   .\n";
      Comment(sComment);
      if (ParserGetKeyIntW("ValueInt") != (1234 + i)) Alert(i, " 6.1.6.1.    \"ParserGetKeyIntW()\".");
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      // 6.1.11.1.       DOUBLE   .   ,   .
      sComment = sComment + string(i) + " 6.1.11.1.       DOUBLE   .   ,   .\n";
      Comment(sComment);
      if (ParserGetKeyDoubleW("ValueDouble") != (987.654 + i)) Alert(i, " 6.1.11.1.    \"ParserGetKeyDoubleW()\".");
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      //  6.1.12.1.        .   ,   .
      sComment = sComment + string(i) + " 6.1.12.1.        .   ,   .\n";
      Comment(sComment);
      if (ParserGetKeyStringW("ValueString") != (string(i) + "  !")) Alert(i, " 6.1.12.1.    \"ParserGetKeyStringW()\".");
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
     }
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 4.1.                 .
    ParserSectionClose();
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.2.6.1.          INT.     .   ,   .
    sComment = sComment + "\n 6.2.6.1.          INT.     .   ,   .\n";
    if (ParserGetKeyIntArrayW("ArrayInt1", a1nInput, 10) != 10) Alert(" 6.2.6.1.    \"ParserGetKeyIntArrayW()\".\n      !");
    for (i = 0; i < 10; i++) if (a1nInput[i] != a1nOutput[i]) Alert(i, " 6.2.6.1.    \"ParserGetKeyIntArrayW()\".\n", a1nInput[i], " != ", a1nOutput[i]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.3.6.1.          INT.     .   ,   .
    sComment = sComment + " 6.3.6.1.          INT.     .   ,   .\n";
    if (ParserGetKeyIntArray2W("ArrayInt2", a2nInput, 3, 3) != 9) Alert(" 6.3.6.1.    \"ParserGetKeyIntArray2W()\".\n      !");
    for (i = 0; i < 3; i++)
     for (j = 0; j < 3; j++)
      if (a2nInput[i][j] != a2nOutput[i][j]) Alert(i, " ", j, " 6.3.6.1.    \"ParserGetKeyIntArray2W()\".\n", a2nInput[i][j], " != ", a2nOutput[i][j]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.4.6.1.          INT.     .   ,   .
    sComment = sComment + " 6.4.6.1.          INT.     .   ,   .\n";
    if (ParserGetKeyIntArray3W("ArrayInt3", a3nInput, 2, 3, 4) != 24) Alert(" 6.4.6.1.    \"ParserGetKeyIntArray3W()\".\n      !");
    for (i = 0; i < 2; i++)
     for (j = 0; j < 3; j++)
      for (k = 0; k < 4; k++)
       if (a3nInput[i][j][k] != a3nOutput[i][j][k]) Alert(i, " ", j, " ", k, " 6.4.6.1.    \"ParserGetKeyIntArray3W()\".\n", a3nInput[i][j][k], " != ", a3nOutput[i][j][k]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.2.11.1.          DOUBLE.     .   ,   .
    sComment = sComment + " 6.2.11.1.          DOUBLE.     .   ,   .\n";
    if (ParserGetKeyDoubleArrayW("ArrayDouble1", a1dInput, 10) != 10) Alert(" 6.2.11.1.    \"ParserGetKeyDoubleArrayW()\".\n      !");
    for (i = 0; i < 10; i++) if (a1dInput[i] != a1dOutput[i]) Alert(i, " 6.2.11.1.    \"ParserGetKeyDoubleArrayW()\".\n", a1dInput[i], " != ", a1dOutput[i]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.3.11.1.          DOUBLE.     .   ,   .
    sComment = sComment + " 6.3.11.1.          DOUBLE.     .   ,   .\n";
    if (ParserGetKeyDoubleArray2W("ArrayDouble2", a2dInput, 3, 3) != 9) Alert(" 6.3.11.1.    \"ParserGetKeyDoubleArray2W()\".\n      !");
    for (i = 0; i < 3; i++)
     for (j = 0; j < 3; j++)
      if (a2dInput[i][j] != a2dOutput[i][j]) Alert(i, " ", j, " 6.3.11.1.    \"ParserGetKeyDoubleArray2W()\".\n", a2dInput[i][j], " != ", a2dOutput[i][j]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.4.11.1.          DOUBLE.     .   ,   .
    sComment = sComment + " 6.4.11.1.          DOUBLE.     .   ,   .\n";
    if (ParserGetKeyDoubleArray3W("ArrayDouble3", a3dInput, 2, 3, 3) != 18) Alert(" 6.4.11.1.    \"ParserGetKeyDoubleArray3W()\".\n      !");
    for (i = 0; i < 2; i++)
     for (j = 0; j < 3; j++)
      for (k = 0; k < 3; k++)
       if (a3dInput[i][j][k] != a3dOutput[i][j][k]) Alert(i, " ", j, " ", k, " 6.4.11.1.    \"ParserGetKeyDoubleArray3W()\".\n", a3dInput[i][j][k], " != ", a3dOutput[i][j][k]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.2.13.1.      MQL4-  .     .   ,   .
    sComment = sComment + " 6.2.13.1.      MQL4-  .     .   ,   .\n";
    if (ParserGetKeyStringArrayMW("ArrayStr1", a1sInput, 10) != 10) Alert(" 6.2.13.1.    \"ParserGetKeyStringArrayMW()\".\n      !");
    for (i = 0; i < 10; i++) if (a1sInput[i] != a1sOutput[i]) Alert(i, " 6.2.13.1.    \"ParserGetKeyStringArrayMW()\".\n", a1sInput[i], " != ", a1sOutput[i]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.3.13.1.      MQL4-  .     .   ,   .
    sComment = sComment + " 6.3.13.1.      MQL4-  .     .   ,   .\n";
    if (ParserGetKeyStringArray2MW("ArrayStr2", a2sInput, 3, 3) != 9) Alert(" 6.3.13.1.    \"ParserGetKeyStringArray2MW()\".\n      !");
    for (i = 0; i < 3; i++)
     for (j = 0; j < 3; j++)
      if (a2sInput[i][j] != a2sOutput[i][j]) Alert(i, " ", j, " 6.3.13.1.    \"ParserGetKeyStringArray2MW()\".\n", a2sInput[i][j], " != ", a2sOutput[i][j]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 6.4.13.1.      MQL4-  .     .   ,   .
    sComment = sComment + " 6.4.13.1.      MQL4-  .     .   ,   .\n";
    if (ParserGetKeyStringArray3MW("ArrayStr3", a3sInput, 2, 3, 3) != 18) Alert(" 6.4.13.1.    \"ParserGetKeyStringArray3MW()\".\n      !");
    for (i = 0; i < 2; i++)
     for (j = 0; j < 3; j++)
      for (k = 0; k < 3; k++)
       if (a3sInput[i][j][k] != a3sOutput[i][j][k]) Alert(i, " ", j, " ", k, " 6.4.13.1.    \"ParserGetKeyStringArray3MW()\".\n", a3sInput[i][j][k], " != ", a3sOutput[i][j][k]);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 1.2.   INI-.
    ParserClose();
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   }
  //====  INI-. =============================================================================================================================================================================================================
  if (Clear)
   {//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "TEST_CLEAR\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 1.4.2.   INI-    ,      ,    ,  ,   ,    -.
    //           INI-     "Open()".     "Close()".
    ParserOpenW(FileName, SectionTag, true);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 3.1.      .
    ParserClearText();
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 1.2.   INI-.
    ParserClose();
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   }
  //====  INI-. =============================================================================================================================================================================================================
  if (Delete)
   {//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "TEST_DELETE\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // 1.3.   INI-.
    ParserDelete();
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   }
 }
//